###########################################################
# site 'stddir_linux.sh' - Bash shell	                  #
#                                                         #
# Created by Keith Thorne, 08 July 2010                   #
#                                                         #
# DO NOT EDIT THIS FILE!                                  #
# This file is part of a production system.               #
###########################################################
# Changes to it effect everyone.  Please play nice        #
# and contact the CDS sys admin if you feel this file     #
# needs to be changed.                                    #
#                                                         #
# $Id: stddir_linux.sh 983 2010-08-17 17:16:42Z keith.thorne@LIGO.ORG $
###########################################################
#  Define default Python version for older OS
DEFPY=2
# Get info on OS - define apps root
#  Check if gentoo
if [ -e /etc/gentoo-release ] ; then
#  If gentoo, determine kernel version
    distname="Gentoo"
    kernrel=`uname -r`
#   get first part  
    kernmajor=${kernrel%%.*}
#   from the rest, get the next one
    kernremain=${kernrel#*.}
    kernminor=${kernremain%%.*}
# the earliest gentoo systems just used /ligo/apps or /opt/rtapps
    if [ "$kernmajor" = "2" ]; then
	OS_ARCH=linux-x86_64
        APPSROOT=${APPSBASEDIR}
    else
	OS_ARCH=gentoo$kernmajor"-"$kernminor
        APPSROOT=${APPSBASEDIR}/$OS_ARCH
    fi
else
# If not gentoo, get the distribution and release from /etc/os-release
    distname=`/usr/bin/awk -F = '$1 == "ID" {gsub(/"/, "", $2); print $2}' <  "/etc/os-release"`
    distrel=`/usr/bin/awk -F = '$1 == "VERSION_ID" {gsub(/"/, "", $2); print $2}' <  "/etc/os-release"`
    distnum=${distrel%%.*}
# check if Ubuntu
    if [ "$distname" = "ubuntu" ]; then
        OS_ARCH=ubuntu$distnum
        if [ $distnum -gt "16" ]; then
            PYDEF=3
        fi  
# check if Scientific Linux
    elif [ "$distname" = "scientific" ]; then
        OS_ARCH=sl$distnum
        if [ $distnum -gt "7" ]; then
            PYDEF=3
        fi  
# check if Rocky
    elif [[ "$distname" = "rocky" ]]; then
        OS_ARCH=rocky$distnum
        if [ $distnum > "7" ]; then
            PYDEF=3
        fi   
# check if CentOS
    elif [ "$distname" = "centos" ]; then
        OS_ARCH=centos$distnum
        if [ $distnum -gt "7" ]; then
            PYDEF=3
        fi   
# check if Debian
    elif [ "$distname" = "debian" ]; then
        OS_ARCH=debian$distnum
        if [ $distnum -gt "9" ]; then
            PYDEF=3
        fi   
# otherwise, mark generic
    else
        OS_ARCH=linux-x86_64
    fi
    APPSROOT=${APPSBASEDIR}/$OS_ARCH
fi
#
export APPSROOT
export OS_ARCH

# SYSBIN should be standard paths (yes, including sbin)
SYSBIN=/usr/bin:/usr/sbin:/bin:/sbin
# SYSLIB as well
SYSLIB=/usr/lib:/lib

# add local if exists
if [ -d "/usr/local" ]; then
    SYSBIN="/usr/local/bin:"${SYSBIN}
    SYSLIB="/usr/local/lib:"${SYSLIB}
fi

# Get info on 32/64-bit
proctype=`uname -m`

# add 64-bit system libraries
EPICSPKGPATH=/usr/lib/epics
if [ "$proctype" = "x86_64" ]; then
#  these tend to be Debian systems
    if [ -d "/lib/x86_64-linux-gnu" ]; then
        EPICSPKGPATH=/usr/lib/epics
        SYSLIB=/lib/x86_64-linux-gnu:${SYSLIB}
        if [ -d "/usr/lib/x86_64-linux-gnu" ]; then
            SYSLIB=/usr/lib/x86_64-linux-gnu:${SYSLIB}
        fi
    else
# these tend to be Redhat, Gentoo
        EPICSPKGPATH=/usr/lib64/epics
        if [ -d "/lib64" ]; then
            SYSLIB=$SYSLIB:/lib64
            if [ -d "/usr/lib64" ]; then
                SYSLIB=$SYSLIB:/usr/lib64
            fi
        fi
    fi
fi
export SYSBIN
export SYSLIB

unset PYTHONREV
unset SYSPYTHON
# figure out the Python rev
# if /usr/bin/python exists, use that
#  -otherwise guess based on OS
if [ -e /usr/bin/python ] ; then
    fullpyvers=$(/usr/bin/python -c 'import platform; print(platform.python_version())')
else
    pyposs=python$PYDEF
    if [ -e /usr/bin/${pyposs} ] ; then
        fullpyvers=$(/usr/bin/${pyposs} -c 'import platform; print(platform.python_version())')
    else
        if [ -e /usr/bin/python3 ] ; then
           fullpyvers=$(/usr/bin/python3 -c 'import platform; print(platform.python_version())')
        else
           fullpyvers=0
        fi
    fi
fi
# If we have python version, continue
if [ $fullpyvers != "0" ] ; then
    # get Python version
    PYTHONREV=`echo ${fullpyvers} | sed -n -e 's/^\([0-9]*\.[0-9]*\).*/\1/p'`
    export PYTHONREV
    # basic system Python path
    SYSPYTHON=/usr/lib/python${PYTHONREV}
    if [ -d /usr/lib/python${PYTHONREV}/dist-packages ]; then
        SYSPYTHON=/usr/lib/python${PYTHONREV}/dist-packages:${SYSPYTHON}
    fi
    if [ -d /usr/lib/python${PYTHONREV}/site-packages ]; then
        SYSPYTHON=/usr/lib/python${PYTHONREV}/site-packages:${SYSPYTHON}
    fi
    export SYSPYTHON
fi

# ** Setup EPICS **
#  Determine EPICS_HOST_ARCH
if [ "$proctype" = "x86_64" ]; then
   EPICS_HOST_ARCH=linux-x86_64
else
   EPICS_HOST_ARCH=linux-x86
fi
unset EPICSBIN
unset EPICSLIB
unset EPICSPERL
unset EPICSPYTHON
# check for /ligo/apps installation
if [ -d ${APPSROOT}/epics ] ; then
    epicstop=${APPSROOT}/epics
    EPICS_BASE=${epicstop}/base
    EPICS_MODULES=${epicstop}/modules
    EPICS_EXTENSIONS=${epicstop}/extensions
    export EPICS_BASE
    export EPICS_MODULES
    export EPICS_EXTENSIONS
    EPICSBIN=${EPICS_BASE}/bin/${EPICS_HOST_ARCH}:${EPICS_EXTENSIONS}/bin/${EPICS_HOST_ARCH}
    EPICSLIB=${EPICS_BASE}/lib/${EPICS_HOST_ARCH}:${EPICS_EXTENSIONS}/lib/${EPICS_HOST_ARCH}
    if [ -d ${EPICS_MODULES}/seq ] ; then
        EPICSBIN=${EPICSBIN}:${EPICS_MODULES}/seq/bin/${EPICS_HOST_ARCH}
        EPICSLIB=${EPICSLIB}:${EPICS_MODULES}/seq/lib/${EPICS_HOST_ARCH}
    fi
    if [ -d ${EPICS_MODULES}/gateway ] ; then
        EPICSBIN=${EPICSBIN}:${EPICS_MODULES}/gateway/bin/${EPICS_HOST_ARCH}
    fi
    export EPICSBIN
    export EPICSLIB
    if [ -d ${EPICS_BASE}/lib/perl ]; then
    	EPICSPERL=${EPICS_BASE}/lib/perl
        export EPICSPERL
    fi 
    if [ -n ${PYTHONREV} ] ; then
        if [ -d ${epicstop}/pyext/pyepics/lib/python$PYTHONREV/site-packages ]; then
            EPICSPYTHON=${epicstop}/pyext/pyepics/lib/python$PYTHONREV/site-packages
            if [ -d ${epicstop}/pyext/pcaspy/lib/python$PYTHONREV/site-packages ]; then
                EPICSPYTHON=${epicstop}/pyext/pcaspy/lib/python$PYTHONREV/site-packages:${EPICSPYTHON}
	        fi
            export EPICSPYTHON
        fi
    fi
    EPICS_MODULES=${epicstop}/modules
    export EPICS_MODULES
else
# otherwise, check for CDS packaged EPICS
    if [ -d ${EPICSPKGPATH} ]; then
        epicstop=${EPICSPKGPATH}
        EPICS_BASE=${epicstop}/base
        EPICS_EXTENSIONS=${epicstop}
        export EPICS_BASE
        export EPICS_EXTENSIONS
        EPICSBIN=${epicstop}/bin/${EPICS_HOST_ARCH}
        EPICSLIB=${epicstop}/lib/${EPICS_HOST_ARCH}
        export EPICSBIN
        export EPICSLIB
        if [ -d ${epicstop}/lib/perl ]; then
    	    EPICSPERL=${epicstop}/lib/perl
            export EPICSPERL
        fi
        if [ -n ${PYTHONREV} ]; then
            if [ -d /usr/lib/python$PYTHONREV/epics ]; then
                EPICSPYTHON=/usr/lib/python$PYTHONREV/site-packages
                if [ -d /usr/lib64/python$PYTHONREV/site-packages/pcaspy ]; then
            	    EPICSPYTHON=/usr/lib64/python$PYTHONREV/site-packages:${EPICSPYTHON}
	            fi
                export EPICSPYTHON
            fi
        fi
        EPICS_MODULES=${epicstop}/modules
        export EPICS_MODULES
   fi
fi
# add paths if they exist
if [ -n ${EPICSBIN} ]; then
    SYSBIN=${EPICSBIN}:${SYSBIN}
fi
if [ -n ${EPICSLIB} ]; then
    SYSLIB=${EPICSLIB}:${SYSLIB}
fi
if [ -n ${EPICSPERL} ]; then
    if [ -n ${SYSPERL} ]; then
        SYSPERL=${SYSPERL}:${EPICSPERL}
    else
        SYSPERL=${EPICSPERL}
    fi 
fi
if [ -n ${EPICSPYTHON} ]; then
    SYSPYTHON=${SYSPYTHON}:${EPICSPYTHON}
fi

# ** setup GDS **

# again, check for /ligo/apps
unset GDSDIR
unset GDSBIN
unset GDSLIB
if [ -d ${APPSROOT}/gds ] ; then
    GDSDIR=${APPSROOT}/gds
    GDSBIN=${GDSDIR}/bin
    GDSLIB=${GDSDIR}/lib
    export GDSDIR
    export GDSBIN
    export GDSLIB
else
# then check for CDS package
    if [ -e /usr/bin/diag ] ; then
        GDSDIR=/usr
        export GDSDIR
    fi   
fi
# add paths if they exist
if [ -n ${GDSBIN} ]; then
    SYSBIN=${GDSBIN}:${SYSBIN}
fi
if [ -n ${GDSLIB} ]; then
    SYSLIB=${GDSLIB}:${SYSLIB}
fi

# ** setup ROOT **
# again /ligo/apps, then check for package install
unset ROOTDIR
unset ROOTBIN
unset ROOTLIB
if [ -d ${APPSROOT}/root ] ; then
    ROOTDIR=${APPSROOT}/root
    ROOTBIN=${ROOTDIR}/bin
    ROOTLIB=${ROOTDIR}/lib/root
    export ROOTDIR
    export ROOTBIN
    export ROOTLIB
else
    if [ -e /usr/bin/rootcint ] ; then
        ROOTDIR=/usr
        export ROOTDIR
    fi
fi
# add paths if they exist
if [ -n ${ROOTBIN} ]; then
    SYSBIN=${ROOTBIN}:${SYSBIN}
fi
if [ -n ${ROOTLIB} ]; then
    SYSLIB=${ROOTLIB}:${SYSLIB}
fi

# ** setup FRAMECPP
# If ldas-tools present, use that
#    Otherwise use framecpp
unset FRAMECPPBIN
unset FRAMECPPLIB
if [ -d "${APPSROOT}/ldas-tools" ]; then
    FRAMECPPBIN=${APPSROOT}/ldas-tools/bin
    FRAMECPPLIB=${APPSROOT}/ldas-tools/lib
elif [ -d "${APPSROOT}/framecpp" ]; then
    FRAMECPPBIN=${APPSROOT}/framecpp/bin
    FRAMECPPLIB=${APPSROOT}/framecpp/lib
fi
# add paths if they exist
if [ -n ${FRAMECPPBIN} ]; then
    SYSBIN=${FRAMECPPBIN}:${SYSBIN}
fi
if [ -n ${FRAMECPPLIB} ]; then
    SYSLIB=${FRAMECPPLIB}:${SYSLIB}
fi

# ** setup LIGOTOOLS **
unset LIGOTOOLS
unset LIGOTOOLBIN
unset LIGOTOOLLIB
if [ -d ${APPSROOT}/ligotools ] ; then
    LIGOTOOLS=${APPSROOT}/ligotools
    LIGOTOOLSBIN=${LIGOTOOLS}/bin
    LIGOTOOLSLIB=${LIGOTOOLS}/lib
    LIGOTOOLSMATLAB=${LIGOTOOLS}/lib
    TCLLIBPATH=${LIGOTOOLS}/lib/tconvert
    export LIGOTOOLS
    export LIGOTOOLSBIN
    export LIGOTOOLSLIB
    export LIGOTOOLSMATLAB
    export TCLLIBPATH
else
   if [ -e /usr/bin/tconvert ] ; then
       LIGOTOOLS=/usr
       LIGOTOOLSBIN=${LIGOTOOLS}/bin
       export LIGOTOOLS
       export LIGOTOOLSBIN
   fi
fi
if [ -n ${LIGOTOOLSBIN} ]; then
    SYSBIN=${LIGOTOOLSBIN}:${SYSBIN}
fi
if [ -n ${LIGOTOOLSLIB} ]; then
    SYSLIB=${LIGOTOOLSLIB}:${SYSLIB}
fi

# ** setup GigE camera server **
unset CAMERABIN
unset CAMERALIB
if [ -d ${APPSROOT}/camera ] ; then
    CAMERABIN=${APPSROOT}/camera/bin
    CAMERALIB=${APPSROOT}/camera/lib
fi
# add paths if they exist
if [ -n ${CAMERABIN} ]; then
    SYSBIN=${CAMERABIN}:${SYSBIN}
fi
if [ -n ${CAMERALIB} ]; then
    SYSLIB=${CAMERALIB}:${SYSLIB}
fi

# ** setup MATLAB
unset MATDIR
if [ -d ${APPSROOT}/matlab ] ; then
    MATDIR=${APPSROOT}/matlab
    export MATDIR
fi

# ** setup Perl modules
unset MODPERL
if [ -d ${APPSROOT}/perlmodules ] ; then
    MODPERL=${APPSROOT}/perlmodules
    export MODPERL
fi
if [ -n ${MODPERL} ] ; then
    if [ -n ${SYSPERL} ]; then
        SYSPERL=${SYSPERL}:${MODPERL}
    else
        SYSPERL=${MODPERL}
    fi 
fi

# ** setup NDS2 **
unset NDS2DIR
unset NDS2BIN
unset NDS2LIB
unset NDS2PYTHON
if [ -d ${APPSROOT}/nds2-client ] ; then
    NDS2DIR=${APPSROOT}/nds2-client
    NDS2BIN=${NDS2DIR}/bin
    NDS2LIB=${NDS2DIR}/lib
    export NDS2DIR
    export NDS2BIN
    export NDS2LIB
    if [ -n ${PYTHONREV} ] ; then
        if [ -d ${NDS2LIB}/python${PYTHONREV}/site-packages ] ; then
            NDS2PYTHON=${NDS2LIB}/python${PYTHONREV}/site-packages
            export NDS2PYTHON
        fi
    fi
else
    if [ -e /usr/bin/nds_query ] ; then
        NDS2DIR=/usr
    fi
fi    
# add paths if they exist
if [ -n ${NDS2BIN} ]; then
    SYSBIN=${NDS2BIN}:${SYSBIN}
fi
if [ -n ${NDS2LIB} ]; then
    SYSLIB=${NDS2LIB}:${SYSLIB}
fi
if [ -n ${NDS2PYTHON} ]; then
    SYSPYTHON=${SYSPYTHON}:${NDS2PYTHON}
fi
  
# ** setup misc python packages
# CDSUTILS
unset CDSUTILSDIR
unset CDSUTILSBIN
unset CDSUTILSLIB
unset CDSUTILSPYTHON
if [ -d ${APPSROOT}/cdsutils ] ; then
    CDSUTILSDIR=${APPSROOT}/cdsutils
    CDSUTILSBIN=${CDSUTILSDIR}/bin
    export CDSUTILSDIR 
    export CDSUTILSBIN
    if [ -n ${PYTHONREV} ]; then
        if [ -d ${CDSUTILSDIR}/lib/python${PYTHONREV}/site-packages ] ; then
            CDSUTILSPYTHON=${CDSUTILSDIR}/lib/python${PYTHONREV}/site-packages
            export CDSUTILSPYTHON
        fi
    fi
else
   if [ -e /usr/bin/cdsutils ] ; then
       CDSUTILSDIR=/usr
       export CDSUTILSDIR 
    fi
fi
# add paths if they exist
if [ -n ${CDSUTILSBIN} ]; then
    SYSBIN=${CDSUTILSBIN}:${SYSBIN}
fi
if [ -n ${CDSUTILSLIB} ]; then
    SYSLIB=${CDSUTILSLIB}:${SYSLIB}
fi
if [ -n ${CDSUTILSPYTHON} ]; then
    SYSPYTHON=${SYSPYTHON}:${CDSUTILSPYTHON}
fi

# GPSTIME
unset GPSTIMEDIR
unset GPSTIMEBIN
unset GPSTIMELIB
unset GPSTIMEPYTHON
if [ -d ${APPSROOT}/gpstime ] ; then
    GPSTIMEDIR=${APPSROOT}/gpstime
    GPSTIMEBIN=${GPSTIMEDIR}/bin
    export GPSTIMEDIR 
    export GPSTIMEBIN
    if [ -n ${PYTHONREV} ]; then
        if [ -d ${GPSTIMEDIR}/lib/python${PYTHONREV}/site-packages ] ; then
            GPSTIMEPYTHON=${APPSROOT}/gpstime/lib/python${PYTHONREV}/site-packages
            export GPSTIMEPYTHON
        fi
    fi
else
    if [ -e /usr/bin/gpstime ] ; then
       GPSTIMEDIR=/usr
       export GPSTIMEDIR 
    fi
fi
# add paths if they exist
if [ -n ${GPSTIMEBIN} ]; then
    SYSBIN=${GPSTIMEBIN}:${SYSBIN}
fi
if [ -n ${GPSTIMELIB} ]; then
    SYSLIB=${GPSTIMELIB}:${SYSLIB}
fi
if [ -n ${GPSTIMEPYTHON} ]; then
    SYSPYTHON=${SYSPYTHON}:${GPSTIMEPYTHON}
fi

# GUARDIAN
unset GUARDIANDIR
unset GUARDIANBIN
unset GUARDIANLIB
unset GUARDIANPYTHON
unset GUARDIANSCREENS
if [ -d ${APPSROOT}/guardian ] ; then
    GUARDIANDIR=${APPSROOT}/guardian
    GUARDIANBIN=${GUARDIANDIR}/bin
    export GUARDIANDIR
    export GUARDIANBIN
    if [ -n ${PYTHONREV} ]; then
        if [ -d ${GUARDIANDIR}/lib/python${PYTHONREV}/site-packages ] ; then
            GUARDIANPYTHON=${GUARDIANDIR}/lib/python${PYTHONREV}/site-packages
            export GUARDIANPYTHON
        fi
    fi
else
   if [ -e /usr/bin/guardian ] ; then
       GUARDIANDIR=/usr
       export GUARDIANDIR
   fi
fi
# add paths if they exist
if [ -n ${GUARDIANBIN} ]; then
    SYSBIN=${GUARDIANBIN}:${SYSBIN}
fi
if [ -n ${GUARDIANLIB} ]; then
    SYSLIB=${GUARDIANLIB}:${SYSLIB}
fi
if [ -n ${GUARDIANPYTHON} ]; then
    SYSPYTHON=${SYSPYTHON}:${GUARDIANPYTHON}
fi
if [ -d ${GUARDIANDIR}/lib/python${PYTHONREV}/site-packages/guardian/medm/screens ] ; then
    GUARDIANSCREENS=${GUARDIANDIR}/lib/python${PYTHONREV}/site-packages/guardian/medm/screens
    export GUARDIANSCREENS
fi
